'draw_test by PaPi 2-jan-2008
uses drawing_routines

'-------------------------------------------------------------
object myform as form
	AutoSize=true
	Onactivate=Main
	ShowHint=true
	Hint="You can testing with left or right click"
end object ' myform
myform.ShowModal

'-------------------------------------------------------------
sub Main()
	ViewPort.Parent=myform
'	definition of viewport in pixels:
	ViewPort.left=0:ViewPort.top=0:ViewPort.width=600:ViewPort.height=600
'   definition of viewport in user-coordinates:
	ViewPort.xleft=-800:ViewPort.xright=800:ViewPort.ydown=-800:ViewPort.ytop=800
'	draw the tests:
	ViewPort.OnMouseDown=DrawTest 
	ViewPort.DrawScale()
	ViewPort.DrawShow()
end sub ' Main

'-------------------------------------------------------------
sub DrawTest(but as integer,u as integer,v as integer)
	ViewPort.DrawScale()
	select case but
		case 1
			DrawTest1(but,u,v)
			exit sub
		case 2
			DrawTest2(but,u,v)
			exit sub
	end select
'	ViewPort.DrawScale()
end sub ' DrawTest

'-------------------------------------------------------------
sub DrawTest1(but as integer,u as integer,v as integer)
	dim x(3) as single,y(3) as single
	dim i as integer
	for i=0 to 3
		x(i)=rnd(1000)-500
		y(i)=rnd(1000)-500
	next i
	ViewPort.DrawLine(x(3),y(3),x(0),y(0),&h80FF,0)
	for i=1 to 3
		ViewPort.DrawLineTo(x(i),y(i),&h80FF,0)
	next i

	ViewPort.DrawCirc(gmap(2,u),gmap(3,v),rnd(500),rnd(&hffffff),false)
	ViewPort.DrawCirc(0,0,rnd(500),rnd(&hffffff),false)
	ViewPort.DrawCirc(0,0,ViewPort.Ring,rnd(&hffffff),false)

	ViewPort.DrawText(X(rnd(3)),Y(rnd(3)),&h8000,"TEST TEST TEST")

	ViewPort.DrawLine(-100,0,0,0,&haa,4)
	ViewPort.DrawLineTo(ViewPort.x0+200*cos(rad(45)),ViewPort.y0+200*sin(rad(45)),&h0cc,4)

	ViewPort.DrawVec(0,0,100,-90+rnd(180),&hdd00,3)
	ViewPort.DrawVecTo(200,-90+rnd(180),&hDD,3)
end sub ' DrawTest1

'-------------------------------------------------------------
sub DrawTest2(but as integer,u as integer,v as integer)
	dim a as single, L as single,color as integer
'drawing random vectors with arrows
	a=180+rnd(360)
	L=(5+rnd(10))*ViewPort.Ring
	color=&hFF
	ViewPort.DrawThickArrow(gmap(2,u),gmap(3,v),L,a,color,1)
	ViewPort.DrawThickArrow(ViewPort.x0,ViewPort.y0,L,a+90,color,2)
	ViewPort.DrawThickArrow(ViewPort.x0,ViewPort.y0,L,a,color,-3)

	ViewPort.DrawArrow(ViewPort.x0,ViewPort.y0,L,a/4,&h008800,0.7)
	ViewPort.DrawArrow(ViewPort.x0,ViewPort.y0,L,a/3,&h008800,1)
	ViewPort.DrawArrow(ViewPort.x0,ViewPort.y0,L/2,a/2,color/2,-2)

end sub ' DrawTest2



